# Manual de &kdesu;

&Geert.Jansen; &Geert.Jansen.mail;
Pablo
de Vicente

    pvicentea@nexo.es

Traductor
Marcos
Fouces Lago

    mfouces@yahoo.es

Traductor
2000
&Geert.Jansen;
&FDLNotice;
21-09-2010
&kde; 4.5

&kdesu; es un interfaz gráfico de la orden &UNIX; `su`.

KDE
su
contraseña
root

## Introducción

¡Bienvenido a &kdesu;! &kdesu; es un interfaz gráfico de la orden &UNIX; `su` para el Entorno de Escritorio K. Le permite ejecutar un programa como usuario diferente proporcionando la contraseña de dicho usuario. &kdesu; es un programa sin privilegios. Utiliza la orden `su` del sistema.

&kdesu; tiene una característica añadida: puede recordar las contraseñas que usted haya introducido previamente. Si usted utiliza esta característica, sólo necesitará introducir una vez la contraseña para cada usuario. Consulte para obtener más información sobre este apartado y sobre el análisis de seguridad.

Este programa se debe iniciar desde la línea de órdenes o desde los archivos `.desktop`. Aunque solicita la contraseña de root utilizando un diálogo &GUI; (gráfico), se puede considerar más una línea de órdenes <-> asociada a un &GUI; que un programa &GUI; puro.

Puesto que `kdesu` ya no está instalado en `$(kde4-config --prefix)`/bin sino en `kde4-config --path libexec` y además no está en su `Path`, tiene que utilizar `$(kde4-config --path libexec)`kdesu`` para lanzar `kdesu`.

## Uso de &kdesu;

El uso de &kdesu; es sencillo. La sintáxis es del tipo:

    kdesu -c  orden  -d -f  archivo -i  nombre del icono  -n -p  prioridad -r -s -t -u  usuario --boton_no_ignorar --attach  winid

    kdesu Opciones genéricas de &kde; Opciones genéricas de &Qt;

Las opciones de la línea de órdenes se explican a continuación.

`-c orden`

  Especifica la instrucción a ejecutar como root. Esta se debe pasar en un argumento. De modo que, por ejemplo, si desea iniciar un nuevo administrador de archivos, debería introducir en el prompt: `$(kde4-config --path libexec)`kdesu `-c &dolphin;```

`-d`

  Mostrar información de depuración.

`-f archivo`

  Esta opción le permite un uso eficiente de &kdesu; en archivos `.desktop`. Le indica a &kdesu; que examine el archivo especificado por `archivo`. Si este archivo tiene privilegios de escritura para el usuario actual, &kdesu; ejecutará la orden como usuario actual. Si no tiene privilegios de escritura, la orden se ejecutará como el usuario `usuario` (de forma predeterminada es root).

  `archivo` se evalúa del siguiente modo: si `archivo` comienza por `/`, se toma como un nombre de archivo absoluto. De lo contrario, se toma como el nombre de un archivo de configuración global de &kde;.

`-i` nombre del icono

  Especifica el icono a utilizar en el diálogo de contraseñas. Puede especificar el nombre sin la extensión.

  Por ejemplo, para ejecutar &konqueror; en modo gestor de archivos y mostrar el icono de &konqueror; en el diálogo de contraseña:

      $(kde4-config --path libexec)kdesu  -i konqueror
       -c "konqueror --profile filemanagement"

`-n`

  No guarda la contraseña. Esto desactiva la casilla guardar contraseña en el diálogo de contraseña.

`-p` prioridad

  Asigne el valor de la prioridad. La prioridad es un número arbitrario entre 0 y 100. 100 es la prioridad más alta y 0 la más baja. El valor predeterminado es 50.

`-r`

  Utilizar planificación en tiempo real.

`-s`

  Detener el demonio kdesu daemon. Consulte .

`-t`

  Activa la salida por terminal. Esta opción desactiva la posibilidad de recordar contraseñas. La razón es por motivos de depuración del código: si desea ejecutar una applicación desde consola, utilice la orden `su` estándar en su lugar.

`-u` usuario

  El uso más común para &kdesu; es ejecutar una orden como superusuario, aunque puede proporcionar un nombre de usuario y la contraseña apropiada.

## Propiedades internas

### Autentificación X

El programa que usted ejecute lo hará bajo el ID de root y habitualmente no tendrá permiso para escribir en su pantalla X. &kdesu; evita este problema añadiendo una cookie de autentificación para su pantalla en un archivo temporal `.Xauthority`. Después de que esta orden finalice, este archivo se suprime.

Si no utiliza cookies X, usted tendrá que resolver este problema por su cuenta. &kdesu; lo detectará y no añadirá una cookie pero usted debe asegurarse de que root tiene acceso a su pantalla.

### Interfaz a `su`

&kdesu; utiliza la orden `su` del sistema para obtener privilegios. En esta sección se explican los detalles de como &kdesu; lleva a cabo esta operación.

Debido a que ciertas implementaciones de `su` (&ie;, la de &RedHat;) no desean leer la contraseña de `stdin`, &kdesu; crea un par pty/tty y ejecuta `su` con sus descriptores de archivos estándar conectados a tty.

Para ejecutar la orden seleccionada por el usuario, en lugar de un intérprete interactivo, &kdesu; utiliza el argumento `-c` con `su`. Este argumento es entendido por todos los intérpretes conocidos y debería por tanto funcionar. `Su` pasa este argumento `-c` al intérprete de destino del usuario y el intérprete de órdenes ejecuta el programa. Ejemplo: `su `root -c el_programa``.

En lugar de ejecutar la orden del usuario directamente con `su`, &kdesu; ejecuta un pequeño programa intermediario denominado kdesu_stub. Este intermediario (ejecutándose como usuario de destino), solicita algo de información de &kdesu; por el canal pty/tty (la entrada y salida estándar del intermediario) y después ejecuta el programa del usuario. La información que se pasa es: la pantalla X, una cookie de acreditación X (si está disponible), la variable `PATH` y la orden a ejecutar. La razón por la que se utiliza un programa intermediario es que la cookie X es información privada y por tanto no se puede pasar en la línea de órdenes.

### Comprobación de contraseñas

&kdesu; comprobará la contraseña introducida y generará un mensaje de error si no es correcta. La comprobación se realiza ejecutando un programa de prueba: `/bin/true`. Si el resultado es positivo, se asumirá que la contraseña es correcta.

### Registro de contraseñas

Para su comodidad, &kdesu; implementa una propiedad de «registro de contraseña». Si está interesado en la seguridad, debería leer el siguiente parrafo.

Si permite que &kdesu; recuerde las contraseñas estará abriendo un (pequeño) agujero en la seguridad de su sistema. Obviamente, &kdesu; no permite más que al identificador de su usuario utilizar sus contraseñas, pero si esto se hace descuidadamente, se rebajaría el nivel de seguridad de root al de un usuario normal (usted). Un hacker (intruso) que consiga acceso a su cuenta, puede conseguir automáticamente el acceso a root. &kdesu; intenta impedir esto. El esquema de seguridad, es razonablemente seguro y se explica a continuación.

&kdesu; utiliza un demonio, llamado kdesud. El demonio escucha a un socket de &UNIX; en `/tmp` listo para ejecutar órdenes. El modo del socket es 0600 de tal manera que sólo su identificador de usuario se pueda conectar a él. Si se activa el registro de contraseñas, &kdesu; ejecuta órdenes a través de este demonio. Escribe la orden y la contraseña de root en el socket y el demonio ejecuta la orden utilizando `su`, como ya se ha descrito anteriormente. Después de esta operación la orden y la contraseña no se descartan. Se registran durante un cierto tiempo. Este tiempo es el valor tiempo de expiración que aparece en el módulo de control. Si llega otra petición para la misma orden durante este periodo de tiempo, el cliente no debe introducir la contraseña. Para evitar que los hackers que puedan entrar en su cuenta roben la contraseña del demonio (por ejemplo añadiendo un depurador), el demonio se instala como set-group-id nogroup. Esto debería impedir el robo de contraseñas del proceso kdesud a todos los usuarios normales (incluyendole a usted). También, el demonio fija la variable de entorno `DISPLAY` al valor que tenía cuando se inició. Lo único que un hacker puede hacer es ejecutar una aplicación en su pantalla.

Un posible problema de este diseño es que los programas que usted ejecuta probablemente no están escritos teniendo en cuenta la seguridad (como los programas setuid root). Ello significa que pueden tener derrames de buffer u otros problemas y un hacker podría explotarlos.

El uso del registro de contraseñas es un compromiso entre seguridad y comodidad. Es recomendable que usted lo piense detenidamente y decida si desea usarlo o no.

## Autor

&kdesu;

Copyright 2000 &Geert.Jansen;

El autor de &kdesu; es &Geert.Jansen;. Está basado de algún modo en la versión 0.3 de &kdesu; de Pietro Iglio. Pietro y el autor acordaron que este programa sería mantenido por el autor actual en el futuro.

Puede contactar con el autor por correo electrónico en &Geert.Jansen.mail;. Por favor informe de cualquier error que encuentre de modo que pueda solucionarlo. Siéntase libre de contactar conmigo para enviar sugerencias.

Traducido por Pablo de Vicente pvicentea@nexo.es y Marcos Fouces Lago mfouces@yahoo.es.

&underFDL; &underArtisticLicense;